#ifndef CREDITS_H
#define CREDITS_H
#if ARDUINO >= 100
  #include "Arduino.h"
#else
  #include "WProgram.h"
#endif

#define DELAY_AFTER_LETTER  500
#define DELAY_AFTER_NAME   3000


// Boot message words
const byte   w_boot_josep[3] PROGMEM = { 3,  2, 5 };
const byte       w_boot_i[3] PROGMEM = { 3,  8, 1 };
const byte     w_boot_ana[3] PROGMEM = { 3, 10, 3 };
const byte    w_boot_dels[3] PROGMEM = { 13, 1, 4 };
const byte      w_boot_de[3] PROGMEM = { 13, 6, 2 };
const byte      w_boot_la[3] PROGMEM = { 13, 9, 2 };
const byte     w_boot_uni[3] PROGMEM = { 13,12, 3 };
const byte      w_boot_12[3] PROGMEM = { 14, 4, 2 };
const byte     w_boot_set[3] PROGMEM = { 14, 7, 3 };
const byte    w_boot_2015[3] PROGMEM = { 14,11, 4 };

// Show the boot message



//void showBootMessage();


#define NUM_NAMES 1 // SET TO NUMBER OF NAMES IN THE LIST

const byte numLettersByName[] PROGMEM =
{
  //7, //version number note number is size of word
  38, // includes repeated characters for pauses -(ver number)then TWENTY SIX NOV 2016 VICKY AND CULLUM
  38, //repeat above
 38, //repeat above
 // 5, //Enric
 // 6, //Isabel
 // 5, //Jordi
//  5, //Laura
 // 5, //Oriol
//  5  //Sergi 
};

 
 
  
const byte letters[] PROGMEM =
{
 
   // co-ord of each letter. Version number shows first on bottom row

   //Version number
   //  3,10,//V
   //  3,11,//E
   //  3,12,//R
    // 8,13,//S
   //  8,14,//I
   //  11,0,//O
    // 11,8,//N
  //   3,12,//Repeat R for pause
  //  15,4, //version number 4
  //  15,13, //version number 7
  //  15,13, //version number 7 // repeat last letter of each word twice to give a pause between words
   

   
   // TWENTYSIXNOV2016VICKYANDCULLUM   
    1, 7, //T
    1, 8, //W
    1,9, //E
    1,10, //N
    1,11, //T
    1,12, // Y
    1,12, // repeat Y of TWENTY once short pause
    2,3, //S
    2,4,  //I
    2,5, // X
    2,5, // repeat X of six to give pause
    3,13,//N
    3,14,//O
    3,15,//V
    3,15, // repeat V of NOV to add a pause pause
    11,12,//2
    11,13,//0
    11,14,//1
    11,15,//6
    11,15, // repeat 6 of 2016 once short pause
    14,0,//V
    14,1,//I
    14,2,//C
    14,3,//K
    14,4,//Y
    14,4,// repeat V of VICKY once short pause
    14,6,//A
    14,7,//N
    14,8,//D
    14,8,//D repeat D of AND once short pause 
    14,10,//C
    14,11,//U
    14,12,//L
    14,13,//L
    14,14,//U
    14,15,//M
    14,15,//repeat M of CULLUM twice for long pause
    14,15,//repeat M of CULLUM twice for long pause
     
  /*

   // TWENTYSIXNOV2016VICKYANDCULLUM   
    1, 7, //T
    1, 8, //W
    1,9, //E
    1,10, //N
    1,11, //T
    1,12, // Y
    1,12, // repeat Y of TWENTY once short pause
    2,3, //S
    2,4,  //I
    2,5, // X
    2,5, // repeat X of six to give pause
    3,13,//N
    3,14,//O
    3,15,//V
    3,15, // repeat V of NOV to add a pause pause
    11,12,//2
    11,13,//0
    11,14,//1
    11,15,//6
    11,15, // repeat 6 of 2016 once short pause
    14,0,//V
    14,1,//I
    14,2,//C
    14,3,//K
    14,4,//Y
    14,4,// repeat V of VICKY once short pause
    14,6,//A
    14,7,//N
    14,8,//D
    14,8,//D repeat D of AND once short pause 
    14,10,//C
    14,11,//U
    14,12,//L
    14,13,//L
    14,14,//U
    14,15,//M
    14,15,//repeat M of CULLUM twice for long pause
    14,15,//repeat M of CULLUM twice for long pause


   // TWENTYSIXNOV2016VICKYANDCULLUM   
    1, 7, //T
    1, 8, //W
    1,9, //E
    1,10, //N
    1,11, //T
    1,12, // Y
    1,12, // repeat Y of TWENTY once short pause
    2,3, //S
    2,4,  //I
    2,5, // X
    2,5, // repeat X of six to give pause
    3,13,//N
    3,14,//O
    3,15,//V
    3,15, // repeat V of NOV to add a pause pause
    11,12,//2
    11,13,//0
    11,14,//1
    11,15,//6
    11,15, // repeat 6 of 2016 once short pause
    14,0,//V
    14,1,//I
    14,2,//C
    14,3,//K
    14,4,//Y
    14,4,// repeat V of VICKY once short pause
    14,6,//A
    14,7,//N
    14,8,//D
    14,8,//D repeat D of AND once short pause 
    14,10,//C
    14,11,//U
    14,12,//L
    14,13,//L
    14,14,//U
    14,15,//M
    14,15,//repeat M of CULLUM twice for long pause
    14,15,//repeat M of CULLUM twice for long pause
 */
};


void creditsManager(unsigned long now, boolean modeChanged);

void setupCreditsNames();

void iterateCreditsNames();

#endif


